grammar Endpoints;
document            : generatorconfig? (compoundType|endpoint)* ;
generatorconfig     : '{' (configitem)? (',' configitem)* '}';
configitem          : configkey ':' configvalue ;
configkey           : IDENTIFIER ;
configvalue         : (IDENTIFIER|VALUE) ;
compoundType        : compoundTypeName compoundFields ;
compoundTypeName    : IDENTIFIER ;
compoundFields      : '(' compoundField (',' compoundField)* ')' ;
compoundField       : fieldName ':' fieldType ;
fieldName           : IDENTIFIER ;
fieldType           : IDENTIFIER ;
endpoint            : path '=<' (compoundType | IDENTIFIER) ;
path                : (pathSegment)+ ;
pathSegment         : '/' (IDENTIFIER|VALUE) ;


fragment DIGIT      : [0-9] ;
fragment LOWERCASE  : [a-z] ;
fragment UPPERCASE  : [A-Z] ;
fragment GENERICS   : '['|']'|'<'|'>' ;
WS                  : [ \t\n\r]+ -> skip;
IDENTIFIER          : (LOWERCASE | UPPERCASE) (LOWERCASE | UPPERCASE | DIGIT | GENERICS)* ;
VALUE               : ~[ ,{}:()/="#';*]+  ;
